#include <X11/Xlib.h>

#define	ACME	20	
#define BORDER	5
#define FLASHES		5
#define TOTAL_COLORS	10

int LEN;

extern int FONT_HEIGHT,milliseconds;
extern int WIDTH,HEIGHT,SCORE,LINES;
extern unsigned char board[10][20];
extern int PIECE,X,Y,PHASE,NEXT,LEVEL;

int color[TOTAL_COLORS];

int RGB[TOTAL_COLORS][3] =
{
	0,	0,	0,
	0,	0,	65535,
	0,	65535,	0,
	0,	65535,	65535,
	65535,	0,	0,
	65535,	0,	65535,
	65535,	65535,	0,
	65535,	65535,	65535,
	65535,	32768,	0,
	16384,	0,	0
};

void draw_score();
void draw_level();

unsigned char COLORS_DONE=0;
void initialize_colors(Display *disp)
{
	int i;
	XColor dummy;
	Colormap colormap;
	int screen;

	screen=DefaultScreen(disp);
	colormap=DefaultColormap(disp,screen);
	for (i=0; i<TOTAL_COLORS; i++)
	{
		dummy.red=RGB[i][0];
		dummy.green=RGB[i][1];
		dummy.blue=RGB[i][2];
		XAllocColor(disp,colormap,&dummy);
		color[i]=dummy.pixel;
	}

	COLORS_DONE=1;
}

void DrawSquare(Display *disp,Window win,GC gc,int x,int y,int col)
{
	XSetForeground(disp,gc,col);
	XFillRectangle(disp,win,gc,x,y,ACME,ACME);
	XSetForeground(disp,gc,color[0]);
	XDrawRectangle(disp,win,gc,x,y,ACME,ACME);
}

void DrawNext(Display *disp,Window win,GC gc)
{
	int i,j;

	for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	if (bit_of_piece(NEXT,j,i,0) == 'x')
		DrawSquare(disp,win,gc,j*ACME,i*ACME,color[NEXT]); else
		DrawSquare(disp,win,gc,j*ACME,i*ACME,color[0]);
}

void DrawCurrentPiece(Display *disp,Window win,GC gc,int method)
{
	int i,j,orgx,orgy;

	orgx=(WIDTH-10*ACME)/2;
	orgy=(HEIGHT-20*ACME)/2;

	for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	if (bit_of_piece(PIECE,j,i,PHASE) == 'x')
	{
		if (method)
			DrawSquare(disp,win,gc,orgx+(X+j)*ACME,orgy+(Y+i)*ACME,color[PIECE]); else
			DrawSquare(disp,win,gc,orgx+(X+j)*ACME,orgy+(Y+i)*ACME,color[0]);
	}
}

void FlashLines(Display *disp,Window win,GC gc,int line[])
{
        int i,j,k,orgx,orgy;

        orgx=(WIDTH-10*ACME)/2;
        orgy=(HEIGHT-20*ACME)/2;           

	for (k=0; k<FLASHES; k++)
	{

	for (i=0; i<20; i++) if (line[i])
	{
		for (j=0; j<10; j++) DrawSquare(disp,win,gc,orgx+j*ACME,orgy+i*ACME,color[7]);
	}
	XSync(disp,False);
	usleep(milliseconds);

        for (i=0; i<20; i++) if (line[i])
        {
                for (j=0; j<10; j++) DrawSquare(disp,win,gc,orgx+j*ACME,orgy+i*ACME,color[0]);
        }
	XSync(disp,False);
        usleep(milliseconds);

	}
}

void DrawGameBoard(Display *disp,Window win,GC gc)
{
	int i,j,orgx,orgy;

	orgx=(WIDTH-10*ACME)/2;
        orgy=(HEIGHT-20*ACME)/2;

	for (i=0; i<20; i++)
	for (j=0; j<10; j++)
	DrawSquare(disp,win,gc,orgx+j*ACME,orgy+i*ACME,color[board[j][i]]);
}

void Redraw(Display *disp,Window win,GC gc)
{
	int width,height,i,j;

	if (!COLORS_DONE) initialize_colors(disp);

/*
	XClearWindow(disp,win);
*/

	XSetForeground(disp,gc,color[8]);
	XFillRectangle(disp,win,gc,(WIDTH-10*ACME)/2-BORDER,(HEIGHT-20*ACME)/2,BORDER,20*ACME+BORDER);
	XFillRectangle(disp,win,gc,(WIDTH-10*ACME)/2+10*ACME+1,(HEIGHT-20*ACME)/2,BORDER,20*ACME+BORDER);
	XFillRectangle(disp,win,gc,(WIDTH-10*ACME)/2,(HEIGHT-20*ACME)/2+20*ACME,10*ACME+1,BORDER);

	DrawGameBoard(disp,win,gc);
	DrawCurrentPiece(disp,win,gc,1);
	DrawNext(disp,win,gc);

	draw_score(disp,win,gc);
	draw_level(disp,win,gc);

	XSync(disp,False);
}

void draw_digit(Display *disp,Window win,GC gc,int orgx,int orgy,char digit)
{
	if (strchr("23567890",digit))
		XSetForeground(disp,gc,color[4]); else
		XSetForeground(disp,gc,color[9]);
	XDrawLine(disp,win,gc,orgx+2,orgy,orgx+2+LEN-1,orgy);
	XDrawLine(disp,win,gc,orgx+3,orgy+1,orgx+2+LEN-2,orgy+1);

        if (strchr("12347890",digit))
                XSetForeground(disp,gc,color[4]); else
                XSetForeground(disp,gc,color[9]);
	XDrawLine(disp,win,gc,orgx+2+LEN+1,orgy+1,orgx+2+LEN+1,orgy+1+LEN-1);
	XDrawLine(disp,win,gc,orgx+2+LEN,orgy+2,orgx+2+LEN,orgy+1+LEN-2);
	XDrawLine(disp,win,gc,orgx+2+LEN-1,orgy+2+1,orgx+2+LEN-1,orgy+1+LEN-2-1);

        if (strchr("134567890",digit))
                XSetForeground(disp,gc,color[4]); else
                XSetForeground(disp,gc,color[9]);
        XDrawLine(disp,win,gc,orgx+2+LEN+1,orgy+1+LEN+1,orgx+2+LEN+1,orgy+1+LEN-1+LEN+1);
        XDrawLine(disp,win,gc,orgx+2+LEN,orgy+2+LEN+1,orgx+2+LEN,orgy+1+LEN-2+LEN+1);
	XDrawLine(disp,win,gc,orgx+2+LEN-1,orgy+2+LEN+1+1,orgx+2+LEN-1,orgy+1+LEN-2+LEN+1-1);

        if (strchr("2356890",digit))
                XSetForeground(disp,gc,color[4]); else
                XSetForeground(disp,gc,color[9]);
        XDrawLine(disp,win,gc,orgx+2,orgy+1+LEN+1+LEN,orgx+2+LEN-1,orgy+1+LEN+1+LEN);
	XDrawLine(disp,win,gc,orgx+3,orgy+1+LEN+1+LEN-1,orgx+2+LEN-1-1,orgy+1+LEN+1+LEN-1);

        if (strchr("2680",digit))
                XSetForeground(disp,gc,color[4]); else
                XSetForeground(disp,gc,color[9]);
	XDrawLine(disp,win,gc,orgx,orgy+1+LEN+1,orgx,orgy+1+LEN-1+LEN+1);
	XDrawLine(disp,win,gc,orgx+1,orgy+1+LEN+1+1,orgx+1,orgy+1+LEN-1+LEN+1-1);
	XDrawLine(disp,win,gc,orgx+1+1,orgy+1+LEN+1+1+1,orgx+1+1,orgy+1+LEN-1+LEN+1-1-1);

        if (strchr("456890",digit))
                XSetForeground(disp,gc,color[4]); else
                XSetForeground(disp,gc,color[9]);
	XDrawLine(disp,win,gc,orgx,orgy+1,orgx,orgy+1+LEN-1);
	XDrawLine(disp,win,gc,orgx+1,orgy+1+1,orgx+1,orgy+1+LEN-1-1);
	XDrawLine(disp,win,gc,orgx+1+1,orgy+1+1+1,orgx+1+1,orgy+1+LEN-1-1-1);

        if (strchr("2345689",digit))
                XSetForeground(disp,gc,color[4]); else
                XSetForeground(disp,gc,color[9]);
	XDrawLine(disp,win,gc,orgx+2,orgy+1+LEN,orgx+2+LEN-1,orgy+1+LEN);
	XDrawLine(disp,win,gc,orgx+2+1,orgy+1+LEN-1,orgx+2+LEN-1-1,orgy+1+LEN-1);
	XDrawLine(disp,win,gc,orgx+2+1,orgy+1+LEN+1,orgx+2+LEN-1-1,orgy+1+LEN+1);
}

void draw_score(Display *disp,Window win,GC gc)
{
	char st[20];
	int i;

	LEN=10;

	sprintf(st,"%6d",SCORE);
	for (i=0; i<6; i++)
	{
		if (st[i] == ' ') st[i]='0';
		draw_digit(disp,win,gc,10+i*(LEN+7),110,st[i]);
	}

	XSync(disp,False);
}

void draw_level(Display *disp,Window win,GC gc)
{
	LEN=20;

	draw_digit(disp,win,gc,WIDTH-80,50,48+LEVEL);
	XSync(disp,False);
}

void show_message(Display *disp,Window win,GC gc,XFontStruct *font,char *msg,int method)
{
	int orgy,wid,a;
	a=(HEIGHT-20*ACME-BORDER)/2+20*ACME+BORDER;
	orgy=HEIGHT-(HEIGHT-a-FONT_HEIGHT)/2;

	wid=XTextWidth(font,msg,strlen(msg));
	if (method)
		XSetForeground(disp,gc,color[2]); else
		XSetForeground(disp,gc,color[0]);
	XSetFont(disp,gc,font->fid);
	XDrawString(disp,win,gc,(WIDTH-wid)/2,orgy,msg,strlen(msg));
	XSync(disp,win);
}
